from typing import Optional, TYPE_CHECKING

from sqlmodel import SQLModel, Field, Relationship

if TYPE_CHECKING:
    from hogwarts_testing_platform.model.user import User


class TestCase(SQLModel, table=True):
    id: Optional[int] = Field(default=None, primary_key=True)
    name: Optional[str] = None
    description: Optional[str] = None
    # 步骤 数据驱动的数据
    steps: Optional[str] = None

    # case维护者
    user_id: Optional[int] = Field(default=None, foreign_key='user.id')
    user: Optional['User'] = Relationship(back_populates='testcase')
