from typing import Optional, TYPE_CHECKING

from sqlmodel import SQLModel, Field, Relationship

if TYPE_CHECKING:
    from hogwarts_testing_platform.model.testcase import TestCase


class User(SQLModel, table=True):
    """数据库绑定"""
    id: Optional[int] = Field(default=None, primary_key=True)
    username: str = Field(unique=True)
    email: Optional[str]
    password: Optional[str]

    testcase: Optional["TestCase"] = Relationship(back_populates='user')
