import abc


class BaseRepo:
    def get(self, id):
        r = self._get(id)
        print(r)
        return r

    @abc.abstractmethod
    def _get(self, id):
        ...

    def list(self):
        for item in self._list():
            yield item

    @abc.abstractmethod
    def add(self, model):
        ...

    @abc.abstractmethod
    def _list(self):
        ...

    def delete(self, id):
        ...
