from typing import Type

from sqlmodel import Session, select, SQLModel

from hogwarts_testing_platform.model.user import User
from hogwarts_testing_platform.repo.base_repo import BaseRepo


class ORMRepo(BaseRepo):
    def __init__(self, session, model):
        # 数据库的连接
        self.session: Session = session
        self.model: Type[SQLModel] = model

    def _get(self, id, name=None):
        if id:
            query = select(self.model).where(self.model.id == id)

        result = self.session.exec(query).first()
        return result

    def _list(self):
        query = select(self.model)
        results = self.session.exec(query)
        return results

    def delete(self, id):
        super().delete(id)

    def add(self, model: SQLModel):
        self.session.add(model)
        self.session.commit()
