from flask import request
from flask.views import MethodView

from hogwarts_testing_platform.model.testcase import TestCase
from hogwarts_testing_platform.repo.repo_factory import RepoFactory
from hogwarts_testing_platform.service.testcase_service import TestCaseService


class CaseRouter(MethodView):
    def get(self, id=None):
        if id:
            case = self.get_service().get(id)
            return case.model_dump()
        if id is None and request.args:
            # 新增
            case = TestCase.model_validate(request.args.to_dict())
            print(case)
            service = self.get_service()
            service.add(case)
            # case2 = case
            case = service.get(case.id)

            print(case.model_dump())
            print(case)
            return case.model_dump()

    def post(self):
        case = TestCase.model_validate(request.json)
        self.get_service().add(case)
        return case.model_dump()

    def get_service(self):
        repo = RepoFactory.get_repo('orm', TestCase)
        case_service = TestCaseService(repo=repo)
        return case_service
