from flask import request
from flask.views import MethodView
from pydantic import BaseModel


class DBItemAPI(MethodView):
    def __init__(self, model: BaseModel):
        # 任意BaseModel的模型
        self.model: BaseDBModel = model

    def _get_item(self, id):
        return db.get_or_404(self.model, id)

    def get(self, id=None):
        # 获取case
        if id is not None:
            # 根据id获取case
            item = self._get_item(id)
            return item.model_dump()
        else:
            # 列出所有case
            users = db.session.execute(db.select(self.model)).scalars()
            return [item.model_dump() for item in users]

    def post(self, id=None):
        # 新增case

        item: db.Model = self.model(**request.json)
        if id is None:
            # CREATE 新增case

            db.session.add(item)
            db.session.commit()
            return item.model_dump()
        else:
            # 根据id更新case  Update
            item = self._get_item(id)
            # todo: 修改
            db.session.commit()
            return item.model_dump()

    def delete(self, id):
        item = self._get_item(id)
        db.session.delete(item)
        db.session.commit()
        return {"message": "删除成功"}
