from flask import request, render_template
from flask.views import MethodView
from pydantic import BaseModel

# from hogwarts_testing_platform.model.testcase import TestCase

# 假的数据库
fake_db: dict[int, BaseModel] = {
    # 1: TestCase(name='demo')
}


class UIItemAPI(MethodView):
    def __init__(self, model: BaseModel):
        # 任意BaseModel的模型
        self.model = model

    def _get_item(self, id):
        return fake_db[id]

    def get(self, id=None, suffix=None):
        # 获取case
        if id is not None:
            # 根据id获取case
            print(id)
            case = fake_db.get(id)
            print(suffix)
            if suffix == 'html':
                return render_template('demo.html', case=case)
            elif suffix == 'json':
                return case.model_dump()
        else:
            # 列出所有case
            return render_template('demo.html')

    def post(self, id=None):
        # 新增case


        case = self.model.model_validate(request.json)

        # service

        if id is None:
            # CREATE 新增case

            fake_db[case.id] = case
            return case.model_dump()
        else:
            # 根据id更新case  Update
            fake_db[id] = case

    def delete(self, id):
        fake_db.pop(id)
