import pytest
from sqlmodel import SQLModel, create_engine, Session

from hogwarts_testing_platform.repo.orm_repo import ORMRepo


@pytest.fixture
def session():
    engine = create_engine("sqlite:///database.db")
    SQLModel.metadata.create_all(engine)
    with Session(engine) as orm_session:
        yield orm_session


def test_list(session):
    orm_repo = ORMRepo(session)
    for user in orm_repo.list():
        print(user.model_dump())


def test_get(session):
    orm_repo = ORMRepo(session)
    user = orm_repo.get(1)
    print(user)
