from hogwarts_testing_platform.model.testcase import TestCase


def test_post(client):
    response = client.post('/testcase', json={'name': 'test', 'description': 'test'})
    print(response)
    print(response.data)
    data = response.json

    print(data)

    assert data['name'] == 'test'

    testcase_id = data['id']
    case2 = TestCase.model_validate(client.get(f'/testcase/{testcase_id}').json)
    assert case2.name == 'test'
    assert case2.id == testcase_id

    data = client.get('/testcase/').json
    case_list = []
    if isinstance(data, list):
        for item in data:
            case = TestCase.model_validate(item)
            case_list.append(case)
    print(data)
    assert len(case_list) >= 1


def test_get(client):
    data = client.get('/testcase/1').json
    assert data['name'] == 'demo'


def test_get_all(client):
    data = client.get('/testcase/').json
    case_list = []
    if isinstance(data, list):
        for item in data:
            case = TestCase.model_validate(item)
            case_list.append(case)
    print(data)
    assert len(case_list) >= 1
